-- initialisation du user PRELEV
-- executer a partir de GRHUM ou PRELEV

CREATE TABLE PRELEV.CLIENT
(
  CLIENT_CATEGORIE_ORDRE  NUMBER,
  CLIENT_ORDRE            NUMBER                NOT NULL,
  DATE_CREATION           DATE                  NOT NULL,
  DATE_EFFET_RIB          DATE                  NOT NULL,
  DATE_MODIF              DATE,
  TYPE_CLIENT             VARCHAR2(32)          NOT NULL,
  NO_INDIVIDU             NUMBER                NOT NULL,
  PERS_ID                 NUMBER                NOT NULL,
  NUMERO_INDEX            NUMBER                NOT NULL,
  RIB_ORDRE               NUMBER                NOT NULL,
  SUPPRIME                VARCHAR2(1)           NOT NULL
);



CREATE TABLE PRELEV.ECHEANCIER
(
  AUTORIS_SIGNEE       VARCHAR2(1)              NOT NULL,
  CLIENT_ORDRE         NUMBER                   NOT NULL,
  CON_ORDRE            NUMBER,
  DATE_1ERE_ECHEANCE   DATE                     NOT NULL,
  DATE_CREATION        DATE                     NOT NULL,
  DATE_MODIF           DATE,
  ECHEANCIER_ORDRE     NUMBER                   NOT NULL,
  ETAT_PRELEVEMENT     VARCHAR2(1),
  FT_ORDRE             NUMBER,
  LIBELLE              VARCHAR2(1000)           NOT NULL,
  MONTANT              NUMBER(12,2)             NOT NULL,
  MONTANT_EN_LETTRES   VARCHAR2(500),
  NOMBRE_ECHEANCES     NUMBER                   NOT NULL,
  NUMERO_INDEX         NUMBER                   NOT NULL,
  ORG_ORDRE            NUMBER                   NOT NULL,
  PREST_ORDRE          NUMBER,
  PRISE_EN_CHARGE      VARCHAR2(1)              NOT NULL,
  REF_FACTURE_EXTERNE  VARCHAR2(200),
  SUPPRIME             VARCHAR2(1)              NOT NULL
);


--
-- PRELEVEMENT  (Table) 
--
CREATE TABLE PRELEV.PRELEVEMENT
(
  ECHEANCIER_ORDRE    NUMBER                    NOT NULL,
  FICP_ORDRE          NUMBER,
  FOU_ORDRE           NUMBER,
  COMMENTAIRE         VARCHAR2(500),
  DATE_MODIF          DATE,
  DATE_PRELEVEMENT    DATE                      NOT NULL,
  PRELEV_DATE_SAISIE  DATE                      NOT NULL,
  PRELEV_ETAT         VARCHAR2(20)              NOT NULL,
  NUMERO_INDEX        NUMBER                    NOT NULL,
  PRELEV_MONTANT      NUMBER(12,2)              NOT NULL,
  PRELEV_ORDRE        NUMBER                    NOT NULL,
  RIB_ORDRE           NUMBER
);


ALTER TABLE PRELEV.CLIENT ADD (
  PRIMARY KEY (CLIENT_ORDRE));


ALTER TABLE PRELEV.ECHEANCIER ADD (
  PRIMARY KEY (ECHEANCIER_ORDRE));


ALTER TABLE PRELEV.PRELEVEMENT ADD (
  PRIMARY KEY (PRELEV_ORDRE));


ALTER TABLE PRELEV.ECHEANCIER ADD (
  CONSTRAINT ECHEANCIER_CLIENT_FK FOREIGN KEY (CLIENT_ORDRE) 
    REFERENCES PRELEV.CLIENT (CLIENT_ORDRE)
    DEFERRABLE INITIALLY DEFERRED);


ALTER TABLE PRELEV.PRELEVEMENT ADD (
  CONSTRAINT PRELEVEMENT_ECHEANCIER_FK 
  FOREIGN KEY (ECHEANCIER_ORDRE) 
    REFERENCES PRELEV.ECHEANCIER (ECHEANCIER_ORDRE)
    DEFERRABLE INITIALLY DEFERRED);

ALTER TABLE PRELEV.CLIENT
 ADD CONSTRAINT FK_CLIENT_PERS_ID
 FOREIGN KEY (PERS_ID)
 REFERENCES GRHUM.PERSONNE (PERS_ID) DEFERRABLE
 INITIALLY DEFERRED ENABLE;

ALTER TABLE PRELEV.CLIENT
 ADD CONSTRAINT FK_CLIENT_NO_IND
 FOREIGN KEY (NO_INDIVIDU)
 REFERENCES GRHUM.INDIVIDU_ULR (NO_INDIVIDU) DEFERRABLE
 INITIALLY DEFERRED ENABLE;

ALTER TABLE PRELEV.CLIENT
 ADD CONSTRAINT FK_CLIENT_RIB_ORDRE
 FOREIGN KEY (RIB_ORDRE)
 REFERENCES GRHUM.RIBFOUR_ULR (RIB_ORDRE) DEFERRABLE
 INITIALLY DEFERRED ENABLE;

ALTER TABLE PRELEV.PRELEVEMENT
 ADD CONSTRAINT FK_PRELEVEMENT_RIB_ORDRE
 FOREIGN KEY (RIB_ORDRE)
 REFERENCES GRHUM.RIBFOUR_ULR (RIB_ORDRE) DEFERRABLE
 INITIALLY DEFERRED ENABLE;
 
ALTER TABLE PRELEV.PRELEVEMENT
 ADD CONSTRAINT FK_PRELEVEMENT_FOU_ORDRE
 FOREIGN KEY (FOU_ORDRE)
 REFERENCES GRHUM.FOURNIS_ULR (FOU_ORDRE) DEFERRABLE
 INITIALLY DEFERRED ENABLE;


-- Les sequences
CREATE SEQUENCE PRELEV.CLIENT_INDEX_SEQ   START WITH 1   
	   MAXVALUE 1E27   MINVALUE 1   NOCYCLE   NOCACHE    NOORDER;
CREATE SEQUENCE PRELEV.CLIENT_SEQ   START WITH 1   
	   MAXVALUE 1E27   MINVALUE 1   NOCYCLE   NOCACHE    NOORDER;
CREATE SEQUENCE PRELEV.ECHEANCIER_INDEX_SEQ  START WITH 1   
	   MAXVALUE 1E27   MINVALUE 1   NOCYCLE   NOCACHE    NOORDER;
CREATE SEQUENCE PRELEV.ECHEANCIER_SEQ START WITH 1   
	   MAXVALUE 1E27   MINVALUE 1   NOCYCLE   NOCACHE    NOORDER;
CREATE SEQUENCE PRELEV.PRELEVEMENT_SEQ START WITH 1   
	   MAXVALUE 1E27   MINVALUE 1   NOCYCLE   NOCACHE    NOORDER;


-- GRANTS autres user
GRANT SELECT ON PRELEV.client to maracuja with grant option;
GRANT SELECT ON PRELEV.echeancier to maracuja  with grant option;
GRANT SELECT ON PRELEV.prelevement to maracuja  with grant option;





